<?
/*

HPE - News Portal Engine
Copyright (C) 2000 Mike Krus

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

if(!isset($HPEprotectmultiincconfig)) {
$HPEprotectmultiincconfig = 1;


if(!isset($HPEinc)) $HPEinc = "./HPE";
if(!isset($HPEext)) $HPEext = "php3";
if(!isset($HPEconfigname)) $HPEconfigname = $HTTP_HOST;

if(ereg("(.*):[0-9]+$", $HPEconfigname, $res)) $HPEconfigname = $res[1];


define("HPEPageEditable", 1);
define("HPEPageExternEdit", 2);
define("HPEPageHidden", 4);

define("HPEModuleEditable", 1);


class HPEBaseConfig {

	var $adminpwd = "";

	var $adminuser = "admin";
	var $adminemail = "admin@email.com";
	var $adminurl = "http://some.url.com/";
	var $adminname = "John Doe";

	var $dbname = "";
	var $dbuser = "";
	var $dbpswd = "";
	var $dbhost = "";
	var $dbuprefix = "";
	var $dbnprefix = "";

	var $siteroot = "/";
	var $siteurl = "http://some.url.com/";
	var $siteabout = "about.php3";
	var $siteerr = "shutdown.html";
	var $nopriv		= "nopriv.php3";
	var $sitename = "HPE News Portal Engine";


	var $shutdown = 0;
	var $storenewsindb = 0;
	var $decaydays = 7;
	var $bgupdate = 0;

	var $cachepath = "cache";
	var $timeout = 3;
	var $timedout = false;
	var $deflang = "fr";
	var $langcodes;
	var $langnames;

	var $errorall = 0;



	var $sitelogo = array("HPE/Images/HPE.gif", 233, 26); // path, width, height
	var $rsitelogo = array("%HPEinc%/Images/HPE.gif", 233, 26); // path, width, height

	var $phpinclude = "";
	var $rphpinclude = "";

	var $htmlbanner = "";
	var $rhtmlbanner = "";

	var $htmlplainbanner = "";
	var $rhtmlplainbanner = "";

	var $htmlfooter = "";
	var $rhtmlfooter = "";

	var $teaser     = "";
	var $rteaser     = "";



	var $pagehandlers;
	var $modhandlers;

	var $themes;
	var $deftheme = 0;

	var $adminmodules;

	var $newsparsers;


	function HPEBaseConfig()
	{
		$this->pagehandlers = array(
				0 => array( "id" => 0,
							"base" => "3cols",
							"rpath" => "%HPEinc%/plugins/",
							"url" => "",
							"name" => "Modules Boxes",
							"desc" => "Arranges your choice of modules in 3 columns", 
							"flags" => (HPEPageEditable | HPEPageExternEdit) ),
			   -1 => array( "id" => -1,
							"base" => "to",
							"rpath" => "%HPEinc%/plugins/",
							"url" => "",
							"name" => "Themes.org",
							"desc" => "Themes.org browser",
							"flags" => HPEPageEditable ),
			   -2 => array( "id" => -2,
							"base" => "randnews",
							"rpath" => "%HPEinc%/plugins/",
							"url" => "",
							"name" => "Random News",
							"desc" => "Show randomly selected news sources",
							"flags" => 0 ),
			   -3 => array( "id" => -3,
							"base" => "newnews",
							"rpath" => "%HPEinc%/plugins/",
							"url" => "",
							"name" => "News News Source",
							"desc" => "Show latest news sources",
							"flags" => 0 ),
				1 => array( "id" => 1,
							"base" => "dmoz",
							"rpath" => "%HPEinc%/plugins/",
							"url" => "",
							"name" => "Web Search",
							"desc" => "Web Search tools and ODP Navigator",
							"flags" => 0 ),
				2 => array( "id" => 2,
							"base" => "teaser",
							"rpath" => "%HPEinc%/plugins/",
							"url" => "",
							"name" => "Teaser",
							"desc" => "Main Page for guest users",
							"flags" => 0 )
			);


		$this->modhandlers = array(
				0 => array( "id" => 0,
							"class" => "HPENewsModule",
							"rpath" => "%HPEinc%/plugins/mod.news.php3",
							"name" => "News Items",
							"desc" => "List of News Items from a given Source", 
							"flags" => (HPEPageEditable) )
			);


		$this->langcodes = array( "fr", "en", "de", "es", "it", "cz", "nl", "dk", "no" );
		$this->langnames = array( "Fran&ccedil;ais", "English", "Deutsch", "Espanol", "Italian", "Czech", "Nederlands", "Dansk", "Norsk" );

		$this->themes = array( array( "name" => "Grey", "rpath" => "%HPEinc%/0" ),
							   array( "name" => "Grey Enhanced", "rpath" => "%HPEinc%/1" ) );

		$this->adminmodules = array ();
		$this->newsparsers = array (
				array( "id" => 0, "rpath" => "%HPEinc%/plugins/news.xmlphp.php3", "name" => "XML PHP", "fct" => "HPEXMLPHPParse" ),
				array( "id" => 1, "rpath" => "%HPEinc%/plugins/news.linenews.php3", "name" => "Line News", "fct" => "HPELINEParse" ),
				array( "id" => 2, "rpath" => "%HPEinc%/plugins/news.blocknews.php3", "name" => "Block News", "fct" => "HPEBLOCKParse" ),
				array( "id" => 3, "rpath" => "%HPEinc%/plugins/news.rawhtml.php3", "name" => "Raw JavaScript", "fct" => "HPERAWJSParse" ),
				array( "id" => 4, "rpath" => "%HPEinc%/plugins/news.rawjs.php3", "name" => "Raw HTML", "fct" => "HPERAWHTMLParse" ),
				array( "id" => 7, "rpath" => "%HPEinc%/plugins/news.htmlnews.php3", "name" => "HTML Parser", "fct" => "HPEHTMLParse" ),
				array( "id" => 9, "rpath" => "%HPEinc%/plugins/news.xmlbi.php3", "name" => "XML Builtin", "fct" => "HPEXMLBIParse" )
			);
	}


	function registerPgHandler($id, $name, $fct, $edit)
	{
/*
		$this->pagehandlers[$id]["base"] = $fct;
		$this->pagehandlers[$id]["name"] = $name;
		$this->pagehandlers[$id]["edit"] = $edit;
*/
	}


	function registerModHandler($id, $name, $fct)
	{
/*
		$this->modhandlers[$id]["base"] = $fct;
		$this->modhandlers[$id]["name"] = $name;
*/
	}


	function init()
	{
		global $HPEinc;

		$this->sitelogo[0] = ereg_replace("^%HPEinc%", $HPEinc, $this->rsitelogo[0]);
		$this->sitelogo[1] = $this->rsitelogo[1];
		$this->sitelogo[2] = $this->rsitelogo[2];
		$this->phpinclude = ereg_replace("^%HPEinc%", $HPEinc, $this->rphpinclude);
		$this->htmlbanner = ereg_replace("^%HPEinc%", $HPEinc, $this->rhtmlbanner);
		$this->htmlplainbanner = ereg_replace("^%HPEinc%", $HPEinc, $this->rhtmlplainbanner);
		$this->htmlfooter = ereg_replace("^%HPEinc%", $HPEinc, $this->rhtmlfooter);
		$this->teaser = ereg_replace("^%HPEinc%", $HPEinc, $this->rteaser);

		for($i=0; $i<count($this->themes); $i++) {
			$this->themes[$i]["path"] = ereg_replace("^%HPEinc%", $HPEinc, $this->themes[$i]["rpath"]);
			$this->themes[$i]["url"]  = ereg_replace("^%HPEinc%", $this->siteroot ."HPE", $this->themes[$i]["rpath"]);
		}

		for($i=0; $i<count($this->newsparsers); $i++) {
			$this->newsparsers[$i]["path"] = ereg_replace("^%HPEinc%", $HPEinc, $this->newsparsers[$i]["rpath"]);
		}

		for($i=0; $i<count($this->adminmodules); $i++) {
			$this->adminmodules[$i]["path"] = ereg_replace("^%HPEinc%", $HPEinc, $this->adminmodules[$i]["rpath"]);
		}

		reset($this->pagehandlers);
		while (list ($key, $val) = each ($this->pagehandlers)) {
			$this->pagehandlers[$key]["path"] = ereg_replace("^%HPEinc%", $HPEinc, $this->pagehandlers[$key]["rpath"]);
		}
		reset($this->pagehandlers);

		reset($this->modhandlers);
		while (list ($key, $val) = each ($this->modhandlers)) {
			$this->modhandlers[$key]["path"] = ereg_replace("^%HPEinc%", $HPEinc, $this->modhandlers[$key]["rpath"]);
		}
		reset($this->modhandlers);
	}


	function chkTimeOut()
	{
		if($this->timeout) {
			$dat = getrusage();
			if($dat["ru_utime.tv_sec"] >= $this->timeout)
				$this->timedout = true;
		}
		return $this->timedout;
	}

};


if(file_exists("$HPEinc/config.$HPEconfigname.$HPEext")) {

	include "$HPEinc/config.$HPEconfigname.$HPEext";
	$HPEtheConfig = new HPEConfig();

} else {

	$HPEtheConfig = new HPEBaseConfig();

}

if($HPEtheConfig->errorall) error_reporting(E_ALL);

if(!isset($HPENOSHUTDOWN)) {

	if($HPEtheConfig->dbname == "")
		die("<H1 align=center>You need to <A HREF=HPE/admin/>configure</A> the site</H1>\n");

	if($HPEtheConfig->shutdown) {

		header("Location: " . $HPEtheConfig->siteurl . $HPEtheConfig->siteerr);
		die("");

	}

}

$HPEtheConfig->init();


} // $HPEprotectmultiincconfig

?>
