<?
/*

HPE - News Portal Engine
Copyright (C) 2000 Mike Krus

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


if(!defined("HPEprotectmultiincpagemaker")) {
define("HPEprotectmultiincpagemaker", 1);


class HPEPageMaker {

	var $message = "";
	var $light = 0;

	var $pagetitle = "";
	var $pageid = 0;
	var $pagetype = 0;
	var $pageindex = -1;


	function HPEPageMaker() 
	{
		$this->message = "";
	}


	function showmessage()
	{
		if($this->message == "") return;
		echo "$this->message";
	}


	function initSession()
	{
		global $HPEtheSession;
		if(isset($HPEtheSession)) $this->light = $HPEtheSession->light;

		global $HPEtheUser;

		$this->message = "";
		if(isset($HPEtheUser)) {
			if($HPEtheUser->nbpages == 0) $this->message = "No defined pages";
		} else $this->message = "No user info";

	}


	function makePagePath($pgn)
	{
		global $HPEtheConfig;

		return $HPEtheConfig->pagehandlers[$this->pagetype]["path"] .
			   "page." .
			   $HPEtheConfig->pagehandlers[$this->pagetype]["base"] .
			   ".$pgn.php3";
	}


	function makepagemenu($pagetitles, $pageurls, $curpage, $pageediturl)
	{
		global $HPEtheConfig;
		global $HPEtheUser;
		global $HPEtheSession;

		global $HPEstrings;

		global $HPEtheThemeMaker;
		$tpl = new FastTemplate($HPEtheThemeMaker->themepath);
		$ex = $HPEtheThemeMaker->mode;
		if($ex != "") $ex .= '.';
		$ex .= "tpl";
		@$tpl->define( array( pagelist => "pagelist.$ex" ) );
		@$tpl->define_dynamic( "items", "pagelist" );

		$l = basename($GLOBALS["PHP_SELF"]) . "?";
		if($GLOBALS["QUERY_STRING"] != "") $l .=  $GLOBALS["QUERY_STRING"] . "&";

		$l = "<A HREF=\"" . $l . "mode=print\">" . $HPEstrings["print"] . "</A>";
		if($pageediturl != "") $l .= "&nbsp;|&nbsp;<A HREF=\"$pageediturl?EDITPAGE=" . $GLOBALS["page"] . "\">" . $HPEstrings["pgmk_edit_page"] . "</A>";
		@$tpl->assign( array( SITEROOT => $HPEtheConfig->siteroot,
							  THEMEROOT => $HPEtheThemeMaker->themeurl,
							  PAGELISTEDIT => $l,
							  PAGELISTTITLE => $HPEstrings["pgmk_list_page"] ) );

		$ncols = count($pagetitles);

		for($i=0; $i<$ncols; $i++) {
			@$tpl->assign( array( PAGELISTTEXT => $pagetitles[$i],
								  PAGELISTLINK => $pageurls[$i],
								  PAGELISTTYPE => ($i == $curpage ? "MENUACTIVE" : "MENUINACTIVE") ) );
			@$tpl->parse(ITEMS, ".items");
		}

		@$tpl->parse(MAIN, "pagelist");
		@$tpl->FastPrint();
	}


	function initpagemenu(&$pagetitles, &$pageurls, &$pageediturl)
	{
		global $HPEtheConfig;
		global $HPEtheUser;
		global $HPEtheSession;

		if($HPEtheSession->userid != 0 && ($HPEtheConfig->pagehandlers[$this->pagetype]["flags"] & HPEPageExternEdit)) {
   			$pageediturl = "editpage.php3";
		} else $pageediturl = "";

		for($i=0; $i<$HPEtheUser->nbpages; $i++) {
			if(!isset($HPEtheConfig->pagehandlers[$HPEtheUser->pagetypes[$i]])) continue;
//			if($HPEtheConfig->pagehandlers[$HPEtheUser->pagetypes[$i]] == "") continue;

			$url = $HPEtheConfig->pagehandlers[$HPEtheUser->pagetypes[$i]]["url"];
			$pageurls[] = $HPEtheSession->url($url, "page=$i");
			$pagetitles[] = ereg_replace(" ", "&nbsp;", trim($HPEtheUser->pagetitles[$i]));
		}
	}


	function beginpage($title)
	{
		global $HPEtheSession;
		$HPEtheSession->update();

		global $HPEtheConfig;
		global $HPEthePager;
		global $HPEstrings;
		global $HPEinc;
		global $HPEtheThemeMaker;

		include ($HPEtheConfig->htmlbanner != "" ?
				 $HPEtheConfig->htmlbanner :
				 $HPEtheThemeMaker->themepath . "/htmlbanner.inc");
	}


	function beginplainpage($title, $subtitle)
	{
		global $HPEtheSession;
		$HPEtheSession->update();

		global $HPEtheConfig;
		global $HPEthePager;
		global $HPEstrings;
		global $HPEinc;
		global $HPEtheThemeMaker;

		include ($HPEtheConfig->htmlplainbanner != "" ?
				 $HPEtheConfig->htmlplainbanner :
				 $HPEtheThemeMaker->themepath . "/htmlplainbanner.inc");
	}


	function beginpopup($title)
	{
		global $HPEtheConfig;
		global $HPEthePager;
		global $HPEstrings;
		global $HPEinc;
		global $HPEtheThemeMaker;

		include ($HPEtheThemeMaker->themepath . "/htmlpopup.inc");
	}


	function endpage($stattag = "")
	{
		global $HPEtheConfig;
		global $HPEtheSession;
		global $HPEthePager;
		global $HPEstrings;
		global $HPEinc;
		global $HPEtheThemeMaker;

		include ($HPEtheConfig->htmlfooter != "" ?
				 $HPEtheConfig->htmlfooter :
				 $HPEtheThemeMaker->themepath . "/htmlfooter.inc");

		global $HPEtheDB;
		global $REMOTE_ADDR;
		$dt = gmdate("ymd");
		$tot = $HPEtheDB->one_data("SELECT total FROM UserAccess WHERE " .
			   "userid=$HPEtheSession->userid AND date='$dt';");
		if($tot == 0) {
			$res = $HPEtheDB->query("INSERT UserAccess SET " .
			   "userid=$HPEtheSession->userid, " .
			   "host='$REMOTE_ADDR', " .
			   "date='$dt', " .
			   "total=1;");
		} else {
			$res = $HPEtheDB->query("UPDATE LOW_PRIORITY UserAccess " .
				"SET total=total+1, host='$REMOTE_ADDR' " .
				"WHERE userid=$HPEtheSession->userid AND date='$dt';");
		}
		if($res == 0) echo "<!-- $HPEtheDB->dberr -->\n";
	}


	function initpage($pg)
	{
		global $HPEtheConfig;
		global $HPEtheUser;
		global $HPEtheNEWSmodule;

		if($HPEtheUser->nbpages == 0) return;

		if($pg == -1) $pg = 0;
		$this->pageindex = $pg;

		if(!isset($HPEtheUser->pagetypes[$this->pageindex])) {
			echo "<P><B>Page number $pg is out of bounds</B></P>";
			return;
		}

		$this->pagetype = $HPEtheUser->pagetypes[$this->pageindex];
		$this->pageid = $HPEtheUser->pageids[$this->pageindex];
		if(!isset($HPEtheConfig->pagehandlers[$this->pagetype])) die("Page type $this->pagetype unsupported");
	}

	function newpage($type, $title)
	{
		global $HPEtheDB;
		global $HPEtheUser;
		global $HPEtheConfig;
		
		if(!isset($HPEtheConfig->pagehandlers[$type])) return -1;
		if(!($HPEtheConfig->pagehandlers[$type]["flags"] & HPEPageEditable)) return 0;

		$query = "INSERT $HPEtheDB->dbtpages SET " .
				 "userid=" . $HPEtheUser->userid . ", " .
				 "layout='', " .
				 "pgtype=0, " .
				 "title='" . addslashes($title) . "';";
		if($HPEtheDB->query($query) == 0) return -1;

		return $HPEtheDB->insert_id();
	}


/*
	function showpage()
	{
		global $HPEtheConfig;
		global $HPEtheUser;

		if($HPEtheUser->nbpages == 0) {
			echo "<P><B>No pages defined. Maybe the database is not responding...<BR>\n";
			if($HPEtheUser->userid) echo "or you need to <A HREF=\"pageprefs.php3\">create some</A>\n";
			echo "</B></P>";
			return;
		}

		if(isset($HPEtheConfig->pagehandlers[$this->pagetype]["base"])) {
			eval ($HPEtheConfig->pagehandlers[$this->pagetype]["base"] . "->show(" . $HPEtheUser->pageids[$this->pageindex] . ");");
		} else {
			echo "<P><B>Unregistered page type '" . $this->pagetype . "' for page '$this->pageindex'</B></P>";
		}

	}

	function isNewsOnPage($modid)
	{
		global $HPEtheConfig;

		if(isset($HPEtheConfig->pagehandlers[$this->pagetype]["base"])) {
			eval ("\$res = " . $HPEtheConfig->pagehandlers[$this->pagetype]["base"] . "->isonpage($modid);");
			return $res;
		} else {
			echo "<P><B>Unregistered page type '" . $this->pagetype . "' for page '$this->pageindex'</B></P>";
			return -1;
		}
	}


	function savePage()
	{
		global $HPEtheConfig;
		eval("\$message = " . $HPEtheConfig->pagehandlers[$this->pagetype]["base"] . "->savePage();");
		return $message;
	}

*/

};



function HPEwindowopener($winname = "hpenews")
{
	global $HPEtheConfig;
?>
<script LANGUAGE="JavaScript1.1"><!--
function displayNews(newsid)
{
	res = window.open('<? echo $HPEtheConfig->siteroot ?>shownews.php3?newsid='+newsid,
					  '<? echo $winname ?>', 'toolbar=no,width=300,height=600');
	res.focus();
}
//--></script>
<?
}


function HPEhelplauncher()
{
	global $HPEtheConfig;
?>
<script LANGUAGE="JavaScript1.1"><!--
function displayHelp(helpid)
{
	res = window.open('<? echo $HPEtheConfig->siteroot ?>help.php3?page='+helpid,
					  'hpehelp', 'toolbar=no,scrollbars=yes,width=400,height=600');
	res.focus();
}

function linkFromHelp(url)
{
	if(window.opener.name == window.name) {
		res = window.open(url);
		res.focus();
	} else {
		window.opener.location.href = url;
		window.opener.focus();
	}
}
//--></script>
<?
}

function HPEhelplink($title, $page = "main")
{
	return "<A HREF=\"javascript:displayHelp('$page')\">$title</A>";
}

function HPEhelplinkback($title, $page = "")
{
	global $HPEtheConfig;
	return "<A HREF=\"javascript:linkFromHelp('$HPEtheConfig->siteroot$page')\">$title</A>";
}


$HPEthePager = new HPEPageMaker();
$HPEthePager->initSession();


} // HPEprotectmultiincpagemaker

?>
