<?
/*

HPE - News Portal Engine
Copyright (C) 2000 Mike Krus

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

if(!defined("HPEBINewsParser")) {
define("HPEBINewsParser", 1);


include "$HPEinc/plugins/xmlbaseparser.php3";


class HPEXMLBINewsParser extends HPEXMLBaseParserTools
{

	function HPEXMLBINewsParser()
	{
		$this->HPEXMLBaseParserTools();

		if(!extension_loaded("XML")) {
			die("XML parser not builtin to the PHP interpreter");
		}

	}

	function parse()
	{
		global $HPEtheNEWSparser;
		
		$this->reset();

		if($HPEtheNEWSparser->openNews()) return -1;

		if($HPEtheNEWSparser->param1 != "") {
			$lt = split(",", $HPEtheNEWSparser->param1);
			$this->tagchannel = $lt[0];
			$this->tagchtitle = $lt[1];
			$this->tagchlink  = $lt[2];
		}

		if($HPEtheNEWSparser->param2 != "") {
			$lt = split(",", $HPEtheNEWSparser->param2);
			$this->tagitem    = $lt[0];
			$this->tagittitle = $lt[1];
			$this->tagitlink  = $lt[2];
//			echo $lt[0] . "-" . $lt[1] . "-" . $lt[2] . "<BR>\n";
		}

		$xml_parser = xml_parser_create();
		// use case-folding so we are sure to find the tag in $map_array
		xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, true);

		xml_set_element_handler($xml_parser, "HPEXMLstartElement", "HPEXMLendElement");
		xml_set_character_data_handler($xml_parser, "HPEXMLcharacterData");
//		xml_set_default_handler($xml_parser, "defaultHandler");
//		xml_set_processing_instruction_handler($xml_parser, "PIHandler");
//		xml_set_external_entity_ref_handler($xml_parser, "externalEntityRefHandler");

		while (!feof($HPEtheNEWSparser->infile)) {
			$data = trim(fread($HPEtheNEWSparser->infile, 4096));
//	$nstr = ereg_replace("<", "&lt;", $data);
//	$nstr = ereg_replace(">", "&gt;", $nstr);
//	echo "<small><pre>$nstr</pre></small><BR>\n"; flush();
			if (!xml_parse($xml_parser, $data, feof($HPEtheNEWSparser->infile))) {
				printf("XML error: %s at line %d",
					   xml_error_string(xml_get_error_code($xml_parser)),
					   xml_get_current_line_number($xml_parser));
				xml_parser_free($xml_parser);
				return -1;
			}
			if($HPEtheNEWSparser->maxitems > 0 && $HPEtheNEWSparser->itemcount >= $HPEtheNEWSparser->maxitems) break;
		}

		if($HPEtheNEWSparser->itemcount == 0) $HPEtheNEWSparser->writeHeader($HPEtheNEWSparser->name, $HPEtheNEWSparser->url);

		xml_parser_free($xml_parser);

		return 0;
	}

};



function HPEXMLstartElement($parser, $name, $attrs)
{
	$nstr = ereg_replace("<", "&lt;", $name);
	$nstr = ereg_replace(">", "&gt;", $nstr);
//	echo "&lt;$nstr&gt;<BR>\n"; flush();
	$GLOBALS["HPEXPLPHPParseWork"]->startElement($name, $attrs);
}


function HPEXMLendElement($parser, $name)
{
	$nstr = ereg_replace("<", "&lt;", $name);
	$nstr = ereg_replace(">", "&gt;", $nstr);
//	echo "&lt;/$nstr&gt;<BR>\n"; flush();
	$GLOBALS["HPEXPLPHPParseWork"]->endElement($name);
}


function HPEXMLcharacterData($parser, $data)
{
//	echo "$data<BR>\n";
	$GLOBALS["HPEXPLPHPParseWork"]->characterData($data);
}



/*

function defaultHandler($parser, $data)
{
	$nstr = ereg_replace("<", "&lt;", $data);
	$nstr = ereg_replace(">", "&gt;", $nstr);
//	echo "DF] $nstr<BR>\n";
}

function PIHandler($parser, $target, $data)
{
	$nstr = ereg_replace("<", "&lt;", $data);
	$nstr = ereg_replace(">", "&gt;", $nstr);
//	echo "PI] $nstr<BR>\n";
}

function externalEntityRefHandler($parser, $openEntityNames, $base, $systemId,
                                                                  $publicId)
{
	return true;
}

*/


}


function HPEXMLBIParse()
{
	global $HPEXPLPHPParseWork;
	$HPEXPLPHPParseWork = new HPEXMLBINewsParser();
	return $HPEXPLPHPParseWork->parse();
}

?>
