<?
/*

HPE - News Portal Engine
Copyright (C) 2000 Mike Krus

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


$file = $HPEthePager->makePagePath("base");
include $file;


require "$HPEinc/loadmodules.php3";


class HPEEditNEWSBoxPager extends HPE3colsPager
{

	function HPEEditNEWSBoxPager($page)
	{
		$this->HPE3colsPager($page);
	}


	function savePage()
	{
		global $HPEtheSession;
		global $HPEtheDB;

		$layout = "";

		if($this->nbitems) for($i=0; $i<count($this->pagedesc); $i++) {
			$sep = $i ? 1 : 0;
			for($j=0; $j<count($this->pagedesc[$i]); $j++) {

				if(!isset($this->pagedesc[$i][$j])) continue;

				$k = $this->pagedesc[$i][$j];
				if($k == -1) continue;

				if($sep) { $layout .= "|"; $sep = 0; }
				elseif($j) $layout .= ";";
				$layout .= $this->pageitems[$k]["type"] . "," .
						   implode(",", $this->pageitems[$k]["params"]);
			}
		}

		$query = "UPDATE $HPEtheDB->dbtpages SET " .
				 "layout='$layout' " .
				 "WHERE pageid=" . $this->pageid . ";";
		$result = $HPEtheDB->query($query);
		if($result == 0) {
			return $HPEtheDB->dberr;
		}

		return "";
	}


	function addModule($type, $param)
	{
		$c = 0;
		if(count($this->pagedesc[1]) < count($this->pagedesc[$c])) $c = 1; 
		if(count($this->pagedesc[2]) < count($this->pagedesc[$c])) $c = 2; 

		$l = isset($this->pagedesc[$c]) ? count($this->pagedesc[$c]) : 0;

		$this->pagedesc[$c][$l] = $this->nbitems;

		$this->pageitems[$this->nbitems] = array(
										"pos" => "$c,$l",
										"type" => $type,
										"params" => split(",", $param)
									);

		$this->nbitems++;

	}


	function removeModule($n)
	{
		if($n < 0 || $n >= $this->nbitems) return;

		$pos = $this->pageitems[$n]["pos"];
		$posxy = split(",", $pos);

		$this->pagedesc[$posxy[0]][$posxy[1]] = -1;

		$this->nbitems--;
	}


	function editModule($n, $param)
	{
		if(!isset($this->pageitems[$n])) die("Wrong module $n");
		
		$this->pageitems[$n]["params"] = split(",", $param);
	}

};


if(!isset($EDITPAGE)) die("Need to specify which page to edit");



$pagework = new HPEEditNEWSBoxPager($EDITPAGE);
$pagework->parse();

$HPEtheSession->loadLang("news");


$message = "";

if(isset($OP)) {

	if($OP == "SAVEORDER") {

		$layout = "";
		$c = @split("\|", $orderedlist);

		for($i=0; $i<count($c); $i++) {

			if($i) $layout .= "|";

			if($c[$i] == "--") {
				$layout .= "--";
				continue;
			}

			$l = split(";", $c[$i]);
			for($j=0; $j<count($l); $j++) {
				if($j) $layout .= ";";
				$layout .= $pagework->pageitems[$l[$j]]["type"] . "," .
						   implode(",", $pagework->pageitems[$l[$j]]["params"]);
			}

		}

		$query = "UPDATE $HPEtheDB->dbtpages SET " .
				 "layout='" . $layout . "' " .
				 "WHERE pageid=" . $HPEthePager->pageid . ";";

		if($HPEtheDB->query($query) == 0)
			$message = "Failed to update database " . $HPEtheDB->dberr . "-->";

	} elseif($OP == "REMOVE") {

		$pagework->removeModule($PARAM);
		$message = $pagework->savePage();

	} elseif($OP == "ADDMOD") {

		if(!isset($TYPE) || !isset($PARAM)) die("Wrong params to ADDMOD command");

		$pagework->addModule($TYPE, $PARAM);
		$message = $pagework->savePage();

	} elseif($OP == "EDITMOD") {

		if(!isset($MOD) || !isset($PARAM)) die("Wrong params to EDITMOD command");

		$pagework->editModule($MOD, $PARAM);
		$message = $pagework->savePage();

	}

	if($message == "") {

		if(isset($done)) {
			header("Location: $done");
			return;
		} else $pagework->parse();

	}

}




$HPEthePager->beginplainpage($HPEstrings["ep_title"], $HPEstrings["ep_subtitle"]);

if(!isset($EDITPAGE)) {
	echo "<P align=center><B>You need to specify a page number!</B></P>";
	$HPEthePager->endpage();
	return;
}

if($HPEtheDB->db == 0) {
	echo "<P align=center><B>$HPEtheDB->dberr</B></P>";
	$HPEthePager->endpage();
	return;
}

if($message) echo "<P align=center><B>$message</B></P>\n\n";

$cols[0] = array();
$cols[1] = array();
$cols[2] = array();

if($pagework->nbitems == 0) {
	echo "<BR><P align=center><B>There is nothing on this page please add modules</B></P>\n\n";
} else {

	for($i=0;$i<count($pagework->pagedesc); $i++) {

		for($j=0; $j<count($pagework->pagedesc[$i]); $j++) {
			if(!isset($pagework->pagedesc[$i][$j])) continue;

			$k = $pagework->pagedesc[$i][$j];
			if($pagework->pageitems[$k]["type"] == "") continue;

			$base = $HPEtheConfig->modhandlers[$pagework->pageitems[$k]["type"]]["control"];
			$name = $base->command( "GETNAME", $pagework->pageitems[$k]);

			$cols[$i][] = $name;
		}

	}

}
echo "<!-- toto -->\n";


?>

<SCRIPT LANGUAGE="JAVASCRIPT">

var strConfirm1 = '<? echo $HPEstrings["ep_confirm1"] ?>';
var strConfirm2 = '<? echo $HPEstrings["ep_confirm2"] ?>';
var strNoSelect = '<? echo $HPEstrings["ep_nocol"] ?>';

function saveOrder() {
    var formName   = "form";
    var i;

    var col1OptObj = eval(docObjName + formName + ".col1.options");
    var col2OptObj = eval(docObjName + formName + ".col2.options");
    var col3OptObj = eval(docObjName + formName + ".col3.options");

    var col1Len = col1OptObj.length;
    var col2Len = col2OptObj.length;
    var col3Len = col3OptObj.length;

    var reslist = eval(docObjName + formName + ".orderedlist");

    reslist.value="";
    if(col1Len == 0) reslist.value += "--";
	else for (i=0;i<col1Len;i++) {
		if(i) reslist.value += ";";
        reslist.value += col1OptObj[i].value;
    }

    reslist.value += "|";
    if(col2Len == 0) reslist.value += "--";
	else for (i=0;i<col2Len;i++) {
		if(i) reslist.value += ";";
        reslist.value += col2OptObj[i].value;
    }

    reslist.value += "|";
    if(col3Len == 0) reslist.value += "--";
	else for (i=0;i<col3Len;i++) {
		if(i) reslist.value += ";";
        reslist.value += col3OptObj[i].value;
    }

	var op   = eval(docObjName + formName + ".OP");
	op.value = "SAVEORDER";
	eval(docObjName + formName + '.submit();');
}


function removeModule() {
	var formName   = "form";
	var i;

	if(curCol == 0) {
		alert(strNoSelect);
		return;
	}

	var colOptObj = eval(docObjName + formName + ".col" + curCol);

	var param = eval(docObjName + formName + ".PARAM");

    var selectedIndex = colOptObj.selectedIndex;
    var selectedValue;
    var selectedText;

    if (selectedIndex != -1) {
        selectedValue=colOptObj[selectedIndex].value;
        if (selectedValue=='-')    { return; }
        selectedText=colOptObj[selectedIndex].text;

		if(confirm(strConfirm1 + '\n "' + 
				   selectedText + '" ' + strConfirm2)) {
			var param = eval(docObjName + formName + ".PARAM");
			param.value = selectedValue;
			var op    = eval(docObjName + formName + ".OP");
			op.value = "REMOVE";
			eval(docObjName + formName + '.submit();');
		}
	}
}

</SCRIPT>

<SCRIPT LANGUAGE="JAVASCRIPT" SRC="HPE/layout.js">
</SCRIPT>

<FORM name="form" ACTION="editpage.php3" METHOD="POST">
<INPUT type=hidden name="orderedlist">
<INPUT type=hidden name="OP" value="NONE">
<INPUT type=hidden name="PARAM" value="">
<INPUT type=hidden name="EDITPAGE" value="<? echo $EDITPAGE ?>">

<? beginsection($HPEstrings["ep_boxtitle"] . " \"" . $pagework->pagetitle . "\""); ?>

<DIV align="center">
<table cellspacing=10 border=0>

<TR><TD align=center COLSPAN=3>
<INPUT TYPE="button" value=" --=   <? echo $HPEstrings["ep_addnewsbox"] ?>   =-- " onClick="top.location.href='<? echo $HPEtheConfig->siteurl . "sitesbycat.php3?onpage=$EDITPAGE" ?>'">
</TD></TR>

<TR valign=top>

<?

for($i=0; $i<3; $i++) {
	echo "<TD align=center NOWRAP><SELECT name=\"col" . ($i+1) . "\" SIZE=6 width=200 onChange=\"setCol(" . ($i+1) . ")\">\n";
	for($j=0; $j<count($cols[$i]); $j++) {
		echo "<OPTION value=" . $pagework->pagedesc[$i][$j] . ">" . $cols[$i][$j] . "\n";
	}
	echo "</SELECT></TD>\n";
}

?>
<TR><TD align=center COLSPAN=3><B>
<A HREF="javascript:moveLeft()"><FONT COLOR="#000000"><? echo $HPEstrings["ep_left"] ?></FONT></A> |
<A HREF="javascript:moveUp()"><FONT COLOR="#000000"><? echo $HPEstrings["ep_up"] ?></FONT></A> |
<A HREF="javascript:moveDown()"><FONT COLOR="#000000"><? echo $HPEstrings["ep_down"] ?></FONT></A> |
<A HREF="javascript:moveRight()"><FONT COLOR="#000000"><? echo $HPEstrings["ep_right"] ?></FONT></A>
</B>
<BR><INPUT TYPE="button" value="   <? echo $HPEstrings["ep_remove"] ?>   " onClick="removeModule()">&nbsp;&nbsp;
<BR>
<small><? echo $HPEstrings["ep_explain"] ?></small></TD></TR>

<TR><TD COLSPAN=3><BR>
<DIV ALIGN="RIGHT"><INPUT TYPE="BUTTON" VALUE="&lt;&lt; <? echo $HPEstrings["ep_back"] ?>" onClick="top.location.href='<? echo $HPEtheConfig->siteurl . "?page=$EDITPAGE" ?>'">&nbsp;&nbsp;
<INPUT TYPE="BUTTON" VALUE="<? echo $HPEstrings["ep_done"] ?> &gt;&gt;" onClick="saveOrder()">&nbsp;&nbsp;</DIV>
</TD></TR>


</table></form></DIV>

<? 

endsection(); echo "<br>\n";
$HPEthePager->endpage();

?>
