<?
/*

HPE - News Portal Engine
Copyright (C) 2000 Mike Krus

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


if(!isset($HPEprotectmultiincsessioninfo)) {

$HPEprotectmultiincsessioninfo = 1;


class HPEUserInfo {

	var $userid = -1;
	var $userlogin = "nobody";
	var $passwd = "";
	var $name = "";

	var $pagetitles;
	var $pageids;
	var $pagetypes;
	var $nbpages = 0;

	var $email = "";
	var $lang = "en";
	var $theme = 0;
	var $flags = 0;
	var $ugroup = 0;

	function HPEUserInfo()
	{
		$this->pagetitles = array();
		$this->pageids = array();
		$this->pagetypes = array();
	}

	function init($id)
	{
		global $HPEtheDB;
		global $HPEtheConfig;

		$this->pagetitles = array();
		$this->pageids = array();
		$this->pagetypes = array();
		$this->nbpages = 0;

		$this->userid = $id;

		if($HPEtheDB->db && $id) {

			global $HPEinc;
			$cache = "$HPEinc/$HPEtheConfig->cachepath/user.$id.inc";
			if(file_exists($cache)) {

				include $cache;

			} else {

				$row = $HPEtheDB->one_array("SELECT * FROM $HPEtheDB->dbtusers WHERE userid=$id;");
				if($row) {
					$this->userlogin = $row["userlogin"];
					$this->name = $row["name"];
					$this->email = $row["email"];

					if($row["pagetitles"] != "" && $row["pageids"] != "") {
						$this->pagetitles = split(",", trim($row["pagetitles"]));

						$pgl = split(",", trim($row["pageids"]));
						for($i=0; $i<count($pgl); $i+=2) {
							$this->pagetypes[] = (int) $pgl[$i];
							$this->pageids[] = (int) $pgl[$i + 1];
							$this->nbpages++;
						}
					}

					$this->lang = strtolower($row["lang"]);
					if($this->lang == "") $this->lang = "en";
					elseif($this->lang == "ge") $this->lang = "de";

					$this->theme = $row["theme"];
					$this->flags = $row["flags"];
					$this->ugroup = $row["ugroup"];

					$cf = fopen($cache, "w");
					if($cf) {
						flock($cf, 2);
						fputs($cf, "<?\n\n" );

						fputs($cf, "\$this->userid = $this->userid;\n");
						fputs($cf, "\$this->userlogin = '$this->userlogin';\n");
						fputs($cf, "\$this->email = '$this->email';\n");
						fputs($cf, "\$this->lang = '$this->lang';\n");
						fputs($cf, "\$this->name = '" . addslashes($this->name) . "';\n");
						fputs($cf, "\$this->flags = $this->flags;\n");
						fputs($cf, "\$this->ugroup = $this->ugroup;\n");
						fputs($cf, "\$this->theme = $this->theme;\n");
						fputs($cf, "\$this->nbpages = $this->nbpages;\n");
						fputs($cf, "\$this->pagetitles = unserialize(stripslashes('" . addslashes(serialize($this->pagetitles)) . "'));\n");
						fputs($cf, "\$this->pageids = unserialize('" . serialize($this->pageids) . "');\n");
						fputs($cf, "\$this->pagetypes = unserialize('" . serialize($this->pagetypes) . "');\n");

						fputs($cf, "\n?>\n" );

						flock($cf, 3);
						fclose($cf);
					}					

				}
			}

		} else {

			$this->nbpages = 4;

			$this->pagetitles[] = "Information";
			$this->pageids[] = 0;
			$this->pagetypes[] = 2;

			if($HPEtheConfig->bgupdate) {
				$this->pagetitles[] = "News Log";
				$this->pageids[] = 0;
				$this->pagetypes[] = -4;
				$this->nbpages++;
			}

			$this->pagetitles[] = -3;
			$this->pageids[] = 0;
			$this->pagetypes[] = -3;

			$this->pagetitles[] = -2;
			$this->pageids[] = 0;
			$this->pagetypes[] = -2;

			$this->pagetitles[] = "Forums";
			$this->pageids[] = 0;
			$this->pagetypes[] = -5;

			$this->flags = 0;
			$this->ugroup = 0;
			$this->lang = $HPEtheConfig->deflang;
			$this->theme = $HPEtheConfig->deftheme;

		}

		global $HPEstrings;
		global $USERLANG;
		global $HPEguestlang;
		if(isset($USERLANG)) {
			$this->lang = strtolower($USERLANG);
			if($this->userid == 0) setcookie("HPEguestlang", $this->lang, time() + 3600, "/");
		} elseif($this->userid == 0 && isset($HPEguestlang)) $this->lang = $HPEguestlang;
		include $GLOBALS["HPEinc"] . "/lang/" . $this->lang . ".inc";

		$this->buildSpecPages();

	}


	function buildSpecPages()
	{
		global $HPEstrings;

		for($i=0; $i<$this->nbpages; $i++) {
			if($this->pagetitles[$i] == -1) {
				$this->pagetitles[$i] = $HPEstrings["pgmk_tobrowser"];
			} elseif($this->pagetitles[$i] == -3) {
				$this->pagetitles[$i] = $HPEstrings["pgmk_newsites"];
			} elseif($this->pagetitles[$i] == -2) {
				$this->pagetitles[$i] = $HPEstrings["pgmk_randsites"];
			}
		}

	}


	function save()
	{
		if($this->userid == 0) return "";

		$this->lang = strtolower($this->lang);

		global $HPEinc;
		global $HPEtheConfig;
		$cache = "$HPEinc/$HPEtheConfig->cachepath/user.$this->userid.inc";
		@unlink($cache);

		global $HPEtheDB;
		if($HPEtheDB->db == 0) return -1;

		if($this->nbpages) {
			$pgt = "";
			$pgi = "";
			for($i=0; $i<$this->nbpages; $i++) {
				if($pgi != "") $pgi .= ",";
				$pgi .= $this->pagetypes[$i] . "," . $this->pageids[$i];
				if($pgt != "") $pgt .= ",";
				$pgt .= $this->pagetitles[$i];
			}
		} else {
			$pgt = "";
			$pgi = "";
		}

		$query = "UPDATE $HPEtheDB->dbtusers SET " .
				 "name=\"" . $this->name. "\", " .
				 "pagetitles=\"$pgt\", " .
				 "pageids=\"$pgi\", " .
				 "lang=\"" . $this->lang . "\", " .
				 "theme=$this->theme, " .
				 "flags=$this->flags, " .
				 "ugroup=$this->ugroup, " .
				 "email=\"" . $this->email . "\"";
		if($this->passwd != "") $query .= ", passwd=\"" . $this->passwd . "\"";
		$query .= " WHERE userid=$this->userid;";

		if($HPEtheDB->query($query)) return ""; else return $HPEtheDB->dberr;
	}

};




class HPESession {

	var $username = "";
	var $userid = 0;
	var $session = "";

	var $isadmin = 0;
	var $lastaccess = 0;
	var $lang = "en";
	var $theme = 0;
	var $light = 0;
	var $extwin = "_self";

	var $mode = "normal";


	function HPESession()
	{
	}


	function saveSession($ui, $un, $session)
	{
		if($ui == 0) return;

		global $HPEtheDB;
		if($HPEtheDB->db == 0) return;
		$query = "REPLACE $HPEtheDB->dbtusersession SET userid=" . $ui . ", " .
				 "sessionid='$session', lastaccess=NOW() ;";
		if($HPEtheDB->query($query) == 0) echo "failed to update session";

		setcookie("HPEsession", $session, time() + 604800, "/");
	}


	function update()
	{
		if($this->userid) {
			$this->saveSession($this->userid, $this->username, $this->session);
		}
	}


	function initSession($havesession = 1)
	{
		global $HPEuser;
		global $HPEsession;

		global $HPEtheConfig;
		global $HPEtheUser;

		$this->session = "";
		$this->lastaccess = 0;
		$this->lang = $HPEtheConfig->deflang;


		global $HTTP_ACCEPT_LANGUAGE;
		if(isset($HTTP_ACCEPT_LANGUAGE)) {
			$httplang = substr($HTTP_ACCEPT_LANGUAGE, 0, 2); 

			if ($httplang == "fr" || $httplang == "en")
				$this->lang = $httplang;
		}


		if(isset($HPEuser)) {

			if($HPEuser != "") {

				$userdata = split("/", $HPEuser);
				if($userdata[0] != "") $this->userid = $userdata[0];
				if($userdata[1] != "") $this->username = $userdata[1];

			}

			if($this->userid != 0 && isset($HPEsession) && $HPEsession != "") {

				global $HPEtheDB;
				if($this->userid && $HPEtheDB->db) {
					$query = "SELECT * FROM $HPEtheDB->dbtusersession WHERE userid=" . $this->userid . " AND sessionid='$HPEsession';";
					if($row = $HPEtheDB->one_array($query)) {
						$this->lastaccess = trim($row["lastaccess"]);
						$this->session = $row["sessionid"];
					}
				}
			}

			if($this->session == "" && $havesession) {
				$this->userid = 0;
				$this->username = "guest";
			}

		}

		if($this->lastaccess == 0) $this->lastaccess = date("YmdHis");
		if($HPEtheConfig->adminuser != "" && ereg($HPEtheConfig->adminuser, $this->username)) $this->isadmin = 1;


		$HPEtheUser->init($this->userid);

		$this->lang  = $HPEtheUser->lang;
		$this->theme = $HPEtheUser->theme;
		$this->extwin = ($HPEtheUser->flags & 2 ? "_new" : "_self");

		global $mode;
		if(isset($mode)) {
			if($mode == "print") $HPEtheUser->mode = "print";
			elseif($mode == "normal") $HPEtheUser->mode = "normal";
			elseif($mode == "wap") $HPEtheUser->mode = "wap";
		} else $HPEtheUser->mode = "normal";
		
		global $HPEtheThemeMaker;
		$HPEtheThemeMaker->initTheme($this->theme, $HPEtheUser->mode);
	}


	function url($t, $q = "")
	{
		global $HPEtheConfig;
		global $page;
		
		$url = $HPEtheConfig->siteroot . $t;
		
		if($q != "") {
			$url .= "?$q";
			$q = "&";
		} else $q = "?";

/*
		if(isset($page)) {
			$url .= $q . "page=$page";
			$q = "&";
		}
*/

		return $url;
	}


	function requireLogin()
	{
		global $HPEtheConfig;
		
		if($this->userid == 0) {
			header("Location: " . $HPEtheConfig->siteurl . $HPEtheConfig->nopriv);
			exit;
		}
	}


	function requireAdmin()
	{
		global $HPEtheConfig;
		
		if(!$this->isadmin) {
			header("Location: " . $HPEtheConfig->siteurl . $HPEtheConfig->nopriv);
			exit;
		}
	}


	function loadLang($file)
	{
		global $HPEtheConfig;
		global $HPEtheSession;
		global $HPEtheUser;

		include $GLOBALS["HPEinc"] . "/lang/" . $this->lang . ".$file.inc";
	}

};




} // $HPEprotectmultiincsessioninfo

?>
